#include <idc.idc>
#include "utils.idc"

static is_auto_gen_fn(str)
{
    auto index;
    index = 0;

    if (substr(str, 0, 2) == "j_")
        index = 2;

    if (substr(str, index, index+4) == "sub_")
        return 1;
    else if (substr(str, index, index+4) == "loc_")
        return 1;
    else if (substr(str, index, index+8) == "nullsub_")
        return 1;

    return 0;
}

static save_names(name)
{
    auto fname, fhandle;
    auto ea;
    auto minea, maxea;
    auto str;
    auto count;

    fname = name;
    if (name == "")
    {
        fname = AskFile(1, "*.txt", "Please enter a dump file name...");
        if (fname == 0)
            return -1;
    }
        
    fhandle = fopen(fname, "w");
    if (fhandle == 0)
        return -2;
    
    minea = MinEA();
    maxea = MaxEA();

    ea = minea;
    count = 0;
    while (ea < maxea && ea != BADADDR)
    {
        ea = NextHead(ea, maxea);
        if (ea == BADADDR) break;

        if (isCode(GetFlags(ea)) && GetFlags(ea) & FF_FUNC)
        {
            str = Name(ea);
            if (str != "" && !is_auto_gen_fn(str))
            {
                fprintf(fhandle, "%08x: %s\n", ea, str);
                count = count + 1;
            }
        }
    }

    fclose(fhandle);

    return count;
}

static load_names(file)
{
    auto fname, fhandle;
    auto force;
    auto line, addr, name;
    auto pos;
    auto str;
    auto count;

    fname = file;
    if (file == "")
    {
        fname = AskFile(0, "*.txt", "Please select a dump file name...");
        if (fname == 0)
            return -1;
    }

    fhandle = fopen(fname, "r");
    if (fhandle == 0)
        return -2;

    force = AskYN(0, "Force renaming of non-autogenerated names?");
    if (force == -1)
        force = 0;
    else if (force == 0)
        force = 0;
    else
        force = 1;

    count = 0;
    do
    {
        line = read_line(fhandle);
        if (line == -1) break;

        addr = parse_int(line);
        if (addr == 0) break;

        pos = strstr(line, ":");
        if (pos == -1) break;

        name = parse_string(substr(line, pos+1, strlen(line)));
        if (name == "") break;

        str = Name(addr);

        if (force == 0 && !is_auto_gen_fn(str))
            if (str != name)
                Message("Skipping (%08x: %s) already has a name: %s\n", addr, name, str);
        else
            MakeName(addr, name);
    } while (line != -1);

    fclose(fhandle);

    return count;
}
